/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/
/*  ̃\[X́AUSB(MSD)USBɏވׂ̃AvTvvOłB

    2019-02-20 ޒH[(ނ) Rg̓{ꉻ(Japanese commentary)
                                   LED"Mount"ONA"Unmount"OFFɕύX
                                   A/Dϊ"adc.c"IWi(analogRead)ɕύX
                                   t@C"LOG,CSV""LOG.TXT"ɕύX
                                   t@Cɏރ^C~O50ms500msɕύX
                                   t@CI[v/݃G[̏ǉ
 */

/** INCLUDES *******************************************************/
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>

//#include "system.h"
#include "usb.h"
#include "fileio.h"
#include "app_host_msd_data_logger.h"
#include "timer_1ms.h"

#define DRIVE_MOUNT_LED  _LATB4    // hCũ}EgԂLED̐ڑs
#define FILE_CLOSE_SW    _RB5      // t@CN[YXCb`̐ڑs

static FILEIO_OBJECT myFile;       // FILEIO_OBJECT^\̂ւ̃|C^

typedef enum
{
    WAITING_FOR_ATTACH,
    MOUNTING_DRIVE,
    OPENING_FILE,
    WAITING_TO_WRITE,
    WRITING_TO_FILE,
    CLOSING_FILE,
    UNMOUNT_DRIVE,
    WAITING_FOR_DETACH
} USB_HOST_MSD_DATA_LOGGER_DEMO_STATE;

static USB_HOST_MSD_DATA_LOGGER_DEMO_STATE MSD_State;
static uint8_t deviceAddress = 0;
static volatile bool sampleRequested = false;
static char printBuffer[10];
static uint8_t blinkCount;

// FILEIO_DRIVE_CONFIG\̂錾āAt@CI/OCufBAƒʐMׂɎgp֐Lq܂
const FILEIO_DRIVE_CONFIG gUSBDrive =
{
    (FILEIO_DRIVER_IOInitialize)NULL,                                    // hCogpI/Os֐
    (FILEIO_DRIVER_MediaDetect)USBHostMSDSCSIMediaDetect,                // fBA}ꂽƂo֐
    (FILEIO_DRIVER_MediaInitialize)USBHostMSDSCSIMediaInitialize,        // fBA֐
    (FILEIO_DRIVER_MediaDeinitialize)USBHostMSDSCSIMediaDeinitialize,    // fBȀ֐
    (FILEIO_DRIVER_SectorRead)USBHostMSDSCSISectorRead,                  // fBAZN^ǂݎ֐
    (FILEIO_DRIVER_SectorWrite)USBHostMSDSCSISectorWrite,                // ZN^fBAɏފ֐
    (FILEIO_DRIVER_WriteProtectStateGet)USBHostMSDSCSIWriteProtectState, // fBA݋֎~ǂ𔻒f֐
};

/*******************************************************************************
*  USB֘Å荞݃nh                                                   *
*******************************************************************************/
void __attribute__((interrupt,auto_psv)) _USB1Interrupt()
{
        // USB荞݂̊荞ݏ[`
        USB_HostInterruptHandler();
}

/*******************************************************************************
*  AiOf[^ǂݏo                                                *
*******************************************************************************/
void analogRead(uint16_t *value)
{
     AD1CON1bits.SAMP = 1;         // TvO̊Jn
     while (!AD1CON1bits.DONE) ;   // ϊ̏I܂ő҂
     *value = ADC1BUF0 ;           // AiOl(AN0)ǂݏo
}

/*********************************************************************
* Function: void APP_HostMSDDataLoggerInitialize(void);
*
* Tv: fR[h܂
*
* O: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostMSDDataLoggerInitialize()
{
    MSD_State = WAITING_FOR_ATTACH;
}

// foCXڑꂽAvGxgnh[R[
void APP_MountDrive(uint8_t address)
{
    if (MSD_State == WAITING_FOR_ATTACH)
    {
        deviceAddress = address;
        MSD_State = MOUNTING_DRIVE;
    }
}

// ^C}[̊荞݂ŃR[nh[
void APP_HostMSDDataLoggerTickHandler(void)
{
    sampleRequested = true;

//    blinkCount++;

//    if(blinkCount > 5)
//    {
//        LED_Toggle(LED_USB_HOST_MSD_DATA_LOGGER);
//        blinkCount = 0;
//    }
}

/*********************************************************************
* Function: void APP_HostMSDDataLoggerTasks(void);
*
* Tv: fs܂B
*
* O: fAPP_HostMSDDataLoggerInitialize()ŏĂ͂łB  
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostMSDDataLoggerTasks()
{
    // fBAp\os܂B
    if(FILEIO_MediaDetect(&gUSBDrive, &deviceAddress) == false)
    {
        // foCX͍폜܂B̐VfoCXڑ̂҂܂B
        MSD_State = WAITING_FOR_ATTACH;
    }
    
    switch( MSD_State)
    {
        case WAITING_FOR_ATTACH:
            break;

        case MOUNTING_DRIVE:       // foCXڑꂽ炱̃Xe[gɂȂ
        {           
            // deviceAddressp[^́AfoCXUSBAhXLڂĂhCuƂ
            // gUSBDriveɂċLqhCu}Eg鎖݂܂B
            // VfoCXoƁAUSB_ApplicationEventHandler֐̃AvP[Vɂď܂B
            if( FILEIO_DriveMount ('A', &gUSBDrive, &deviceAddress) == FILEIO_ERROR_NONE)
            {
                DRIVE_MOUNT_LED = 1 ;     // hCũ}EgԂLED_
                MSD_State = OPENING_FILE;
            }
            break;
        }

        case OPENING_FILE:
            // FILEIO_OPEN_WRITEIvVŃt@CJƁAt@Cɏގł܂B
            // FILEIO_OPEN_CREATEt@CŃt@CJƁAt@C݂Ȃꍇ͍쐬܂B
            // FILEIO_OPEN_TRUNCATEt@CŃt@CJƁAłɑ݂ꍇ́A0̃t@Cɐ؂̂Ă܂B
            if(FILEIO_Open(&myFile, "LOG.TXT", FILEIO_OPEN_WRITE | FILEIO_OPEN_CREATE | FILEIO_OPEN_TRUNCATE) == FILEIO_RESULT_SUCCESS)
            {
                MSD_State = WRITING_TO_FILE;

                blinkCount = 0;
                sampleRequested = false;
                // 500msAPP_HostMSDDataLoggerTickHandlerslɃZbgB
                // Ď500msɃt@C݂sƂłˁB
                TIMER_RequestTick(&APP_HostMSDDataLoggerTickHandler, 500);
//                LED_On(LED_USB_HOST_MSD_DATA_LOGGER);
//                ADC_ChannelEnable(ADC_USB_HOST_MSD_DATA_SOURCE);
                break;
            } else {
                // t@CJłȂꍇ́A
                // foCXɏ߂Ȃ̂ŁA݂𒆎~ăfoCX폜̂҂܂B
                // A"FILEIO_DriveMount"͐Ă͂Ȃ̂"FILEIO_DriveUnmount"s܂B
                MSD_State = UNMOUNT_DRIVE;
            }
            break;

        case WRITING_TO_FILE:
            if(sampleRequested == true)
            {
                uint16_t  adcResult;
                int charCount, ans ;

                sampleRequested = false;
                
                analogRead(&adcResult) ;  // ŒR̒lǂݍ

                charCount = sprintf(printBuffer, "%d\r\n", adcResult);
                
                // Vt@CɃf[^݂܂B
                ans = FILEIO_Write(printBuffer, 1, charCount, &myFile);
                if (ans != charCount) {
                     // G[̓N[Yɓ
                     ans = FILEIO_ErrorGet('A') ;
                     MSD_State = CLOSING_FILE ;                     
                }
            }
            // {^ꂽt@CN[YAhCuA}Eg鏈Jn
            if(FILE_CLOSE_SW == 0)
            {
                MSD_State = CLOSING_FILE;
            }
            break;

        case CLOSING_FILE:
            // f[^hCuɏ܂lɕKt@CĂB
            FILEIO_Close(&myFile);
            // 500ms̃^C}[s܂B
            TIMER_CancelTick(&APP_HostMSDDataLoggerTickHandler);

            MSD_State = UNMOUNT_DRIVE;
            break;

        case UNMOUNT_DRIVE:
            // hCu͎gpȂȂ̂Ń}Eg܂B
            FILEIO_DriveUnmount ('A');

            // ݂̂ŁAhCuO܂ŉł܂B
            MSD_State = WAITING_FOR_DETACH;
            break;

        case WAITING_FOR_DETACH:
              DRIVE_MOUNT_LED = 0 ;     // hCũ}EgԂLED
        break;

        default:
            break;
    }
}
