/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/
/*  ̃\[X́AUSB(MSD)USBǂݍވׂ̃AvTvvOłB

    2019-02-20 ޒH[(ނ) Rg̓{ꉻ(Japanese commentary)
 */

/** INCLUDES *******************************************************/
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>

#include "usb.h"
#include "fileio.h"
#include "app_host_msd_data_logger.h"
#include "skUARTlib.h"

#define DRIVE_MOUNT_LED  _LATB4    // hCũ}EgԂLED̐ڑs

static FILEIO_OBJECT myFile;       // FILEIO_OBJECT^\̂ւ̃|C^

typedef enum
{
    WAITING_FOR_ATTACH,
    MOUNTING_DRIVE,
    OPENING_FILE,
    READING_TO_FILE,
    CLOSING_FILE,
    UNMOUNT_DRIVE,
    WAITING_FOR_DETACH
} USB_HOST_MSD_DATA_LOGGER_DEMO_STATE;

static USB_HOST_MSD_DATA_LOGGER_DEMO_STATE MSD_State;
static uint8_t deviceAddress = 0;

// FILEIO_DRIVE_CONFIG\̂錾āAt@CI/OCufBAƒʐMׂɎgp֐Lq܂
const FILEIO_DRIVE_CONFIG gUSBDrive =
{
    (FILEIO_DRIVER_IOInitialize)NULL,                                    // hCogpI/Os֐
    (FILEIO_DRIVER_MediaDetect)USBHostMSDSCSIMediaDetect,                // fBA}ꂽƂo֐
    (FILEIO_DRIVER_MediaInitialize)USBHostMSDSCSIMediaInitialize,        // fBA֐
    (FILEIO_DRIVER_MediaDeinitialize)USBHostMSDSCSIMediaDeinitialize,    // fBȀ֐
    (FILEIO_DRIVER_SectorRead)USBHostMSDSCSISectorRead,                  // fBAZN^ǂݎ֐
    (FILEIO_DRIVER_SectorWrite)USBHostMSDSCSISectorWrite,                // ZN^fBAɏފ֐
    (FILEIO_DRIVER_WriteProtectStateGet)USBHostMSDSCSIWriteProtectState, // fBA݋֎~ǂ𔻒f֐
};

/*******************************************************************************
*  USB֘Å荞݃nh                                                   *
*******************************************************************************/
void __attribute__((interrupt,auto_psv)) _USB1Interrupt()
{
        // USB荞݂̊荞ݏ[`
        USB_HostInterruptHandler();
}

/*********************************************************************
* Function: void APP_HostMSDDataLoggerInitialize(void);
*
* Tv: fR[h܂
*
* O: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostMSDDataLoggerInitialize()
{
    MSD_State = WAITING_FOR_ATTACH;
}

// foCXڑꂽAvGxgnh[R[
void APP_MountDrive(uint8_t address)
{
    if (MSD_State == WAITING_FOR_ATTACH)
    {
        deviceAddress = address;
        MSD_State = MOUNTING_DRIVE;
    }
}

/*********************************************************************
* Function: void APP_HostMSDDataLoggerTasks(void);
*
* Tv: fs܂B
*
* O: fAPP_HostMSDDataLoggerInitialize()ŏĂ͂łB  
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_HostMSDDataLoggerTasks()
{
    int ans ;

    // fBAp\os܂B
    if(FILEIO_MediaDetect(&gUSBDrive, &deviceAddress) == false)
    {
        // foCX͍폜܂B̐VfoCXڑ̂҂܂B
        MSD_State = WAITING_FOR_ATTACH;
    }
    
    switch( MSD_State)
    {
        case WAITING_FOR_ATTACH:
            break;

        case MOUNTING_DRIVE:       // foCXڑꂽ炱̃Xe[gɂȂ
        {           
            // deviceAddressp[^́AfoCXUSBAhXLڂĂhCuƂ
            // gUSBDriveɂċLqhCu}Eg鎖݂܂B
            // VfoCXoƁAUSB_ApplicationEventHandler֐̃AvP[Vɂď܂B
            if( FILEIO_DriveMount ('A', &gUSBDrive, &deviceAddress) == FILEIO_ERROR_NONE)
            {
                DRIVE_MOUNT_LED = 1 ;     // hCũ}EgԂLED_
                MSD_State = OPENING_FILE;
            }
            break;
        }

        case OPENING_FILE:
            // t@CJēǂݍ݂s܂Bt@C݂Ȃ΃G[łB
            if(FILEIO_Open(&myFile, "TEST.TXT", FILEIO_OPEN_READ) == FILEIO_RESULT_SUCCESS)
            {
                MSD_State = READING_TO_FILE;
                break;
            } else {
                // t@CJłȂꍇ́A
                // foCXɏ߂Ȃ̂ŁA݂𒆎~ăfoCX폜̂҂܂B
                // A"FILEIO_DriveMount"͐Ă͂Ȃ̂"FILEIO_DriveUnmount"s܂B
                UART_Send("FILE OPEN ERROR!",16) ;
                MSD_State = UNMOUNT_DRIVE;
            }
            break;

        case READING_TO_FILE:
            // t@Cf[^1oCgPʂœǂݍ݂܂B
            ans = FILEIO_GetChar(&myFile);
            if (ans == FILEIO_RESULT_FAILURE) {
                 // G[̓N[Yɓ
                 ans = FILEIO_ErrorGet('A') ;
                 MSD_State = CLOSING_FILE ;
            } else {
                 // obɑ
                 UART_Write((char)ans) ;
            }
            break;

        case CLOSING_FILE:
            // f[^hCuɏ܂lɕKt@CĂB
            FILEIO_Close(&myFile);
            MSD_State = UNMOUNT_DRIVE;
            break;

        case UNMOUNT_DRIVE:
            // hCu͎gpȂȂ̂Ń}Eg܂B
            FILEIO_DriveUnmount ('A');
            // ݂̂ŁAhCuO܂ŉł܂B
            MSD_State = WAITING_FOR_DETACH;
            break;

        case WAITING_FOR_DETACH:
              DRIVE_MOUNT_LED = 0 ;     // hCũ}EgԂLED
        break;

        default:
            break;
    }
}
